package com.chuanglan.shanyan_sdk_test_demo.view;

import android.Manifest;
import android.app.AlertDialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.content.pm.PackageManager;
import android.os.Build;
import android.os.Bundle;
import android.support.annotation.NonNull;
import android.support.v4.app.ActivityCompat;
import android.support.v4.content.ContextCompat;
import android.util.Log;
import android.view.WindowManager;

import com.chuanglan.shanyan_sdk.OneKeyLoginManager;
import com.chuanglan.shanyan_sdk.listener.GetPhoneInfoListener;
import com.chuanglan.shanyan_sdk_test_demo.R;
import com.chuanglan.shanyan_sdk_test_demo.utils.NetworkMgsUtils;

public class SplashActivity extends BaseActivity {
    private int MY_READ_PHONE_STATE = 0;

    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.shanyan_demo_activity_splash);
        requestPermission(Manifest.permission.READ_PHONE_STATE);
    }

    private void requestPermission(String permission) {
        if (ContextCompat.checkSelfPermission(this, permission) != PackageManager.PERMISSION_GRANTED) {
            if ("OPPO".equals(Build.MANUFACTURER)) {
                startRunnable(permission);
            } else {
                ActivityCompat.requestPermissions(SplashActivity.this, new String[]{permission}, MY_READ_PHONE_STATE);
            }
        } else {
            //闪验SDK预取号（可缩短拉起授权页时间）
            final long time = System.currentTimeMillis();
            OneKeyLoginManager.getInstance().getPhoneInfo(new GetPhoneInfoListener() {
                @Override
                public void getPhoneInfoStatus(int code, String result) {
                    //预取号回调
                    NetworkMgsUtils.PRE_COST_TIME = System.currentTimeMillis() - time;
                    Log.e("VVV", "预取号： code==" + code + "   result==" + result + " NetworkMgsUtils.INIT_COST_TIME=" + NetworkMgsUtils.INIT_COST_TIME);
                    Intent intent = new Intent(SplashActivity.this, SelectorActivity.class);
                    startActivity(intent);
                    finish();
                }
            });
        }
    }

    @Override
    public void onRequestPermissionsResult(int requestCode, @NonNull String[] permissions, @NonNull int[] grantResults) {
        super.onRequestPermissionsResult(requestCode, permissions, grantResults);
        //无论权限是否申请成功，均调用闪验预取号方法
        if (requestCode == MY_READ_PHONE_STATE) {
            //闪验SDK预取号（可缩短拉起授权页时间）
            final long time = System.currentTimeMillis();
            OneKeyLoginManager.getInstance().getPhoneInfo(new GetPhoneInfoListener() {
                @Override
                public void getPhoneInfoStatus(int code, String result) {
                    //预取号回调
                    NetworkMgsUtils.PRE_COST_TIME = System.currentTimeMillis() - time;
                    Log.e("VVV", "预取号： code==" + code + "   result==" + result);
                    Intent intent = new Intent(SplashActivity.this, SelectorActivity.class);
                    startActivity(intent);
                    finish();
                }
            });
        }
    }

    private void startRunnable(final String permission) {
        AlertDialog.Builder builder = new AlertDialog.Builder(this);
        builder.setTitle("提示");
        builder.setMessage("将会有一些权限需要被授予");
        builder.setPositiveButton("确定", new DialogInterface.OnClickListener() {
            @Override
            public void onClick(DialogInterface dialog, int which) {
                ActivityCompat.requestPermissions(SplashActivity.this, new String[]{permission}, MY_READ_PHONE_STATE);
            }
        });
        builder.setCancelable(false);//弹出框不可以返回键取消
        AlertDialog dialog = builder.create();
        dialog.getWindow().setType(WindowManager.LayoutParams.TYPE_SYSTEM_ALERT);//将弹出框设置为全局
        dialog.setCanceledOnTouchOutside(false);//失去焦点不会消失
        builder.show();
    }
}
